package net.jxta.impl.shell.bin.ping;

import java.util.*;

/**
 * Extends PingEvent to include the first leg differential as a message component.
 */
public class PingReplyEvent extends PingEvent {
    

    long time = 0;
    
    public PingReplyEvent(Object source, long diff, long otime, long atime, String name) {
        super(source,name,otime,atime);
        this.time = diff;
    }
       
    /**
     * @return Returns the time differential between the sender
     * and receiver of the previous leg of a ping.
     */
    public long getPriorDifferential() {
        return time;
    }
    
}
