/*
 * ContentRequestHandler.java
 *@author  Daniel Brookshier turbogeek@cluck.com
 * Created on September 2, 2001, 10:49 PM
 */

package com.sams.jxta.updateCMS;
import java.util.ArrayList;
import net.jxta.protocol.PipeAdvertisement;
import net.jxta.peergroup.PeerGroup;
import java.lang.reflect.InvocationTargetException;


import net.jxta.share.*;
import net.jxta.share.client.*;
import java.io.File;
/**
 * This class creates an publisher/listenter interface for the
 * CMS manager in JXTA.
 *
 * Note GetContentRequest.java, 1.4 2001/07/06 may fail without notification.
 *
 *
 * @author  Daniel Brookshier turbogeek@cluck.com
 * @version
 */
public class ContentRequestHandler extends GetContentRequest {
   
   
   /** Creates new ContentRequestHandler */
   public ContentRequestHandler(PeerGroup group, ContentAdvertisement cAdv, File inFile) throws InvocationTargetException {
      super(group, cAdv, inFile);
   }
   public void notifyDone() {
      fire(new ContentEvent(this,ContentEvent.LOAD_DONE,getPercentDone(),hasFailed(),isDone()));
   }
   
   public void notifyFailure() {
      fire(new ContentEvent(this,ContentEvent.LOAD_FAIL,getPercentDone(),hasFailed(),isDone()));
   }
   
   public void notifyUpdate(int percentage) {
      fire(new ContentEvent(this,ContentEvent.LOAD_PROGRESS,percentage,hasFailed(),isDone()));
   }
   //Helper class to hold listeners
   protected ArrayList listenerList = null;
  
   
   public void addContentListener(ContentListener listenter) {
      if(listenerList  == null){
         listenerList = new ArrayList(1);
      }
      listenerList.add( listenter);
   }
   
   public void removeContentListener(ContentListener listenter) {
      listenerList.remove(listenerList.indexOf( listenter));
   }
   
   /**
    * Notify all listeners that have registered interest for
    * notification on this event type.
    */
   
   protected void fire(ContentEvent contentEvent) {
      if(listenerList  == null){
         return;
      }else{
         for (int i = 0; i < listenerList.size();i++) {
            ((ContentListener)listenerList.get(i)).contentEvent(contentEvent);
         }
      }
   }
   
   
   
}
