/*
 * MirrorLibrary.java
 *
 * Created on September 1, 2001, 1:26 PM
 */

package com.sams.jxta.updateCMS;

import javax.swing.*;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.DefaultMutableTreeNode;
import java.io.*;
import net.jxta.share.ContentAdvertisement;
/**
 *
 * @author  Administrator
 */
public class MirrorLibrary extends JFrame {
   protected UpdateCMS platform;
   /** Creates new form MirrorLibrary */
   public MirrorLibrary(UpdateCMS platform) {
      this.platform = platform;
      initComponents();
      DefaultTreeModel model = new DefaultTreeModel(new DefaultMutableTreeNode("root") );
      localContentTree.setModel(model);
     
      getFileDescTreeModel().setRoot(new DefaultMutableTreeNode("") );      
   }
   protected ContentAdvertisement[] results;// need to synchronize access.
   public void displayDocumentsFound(ContentAdvertisement[] results) {
            this.results = results;            
            DefaultListModel model = new DefaultListModel();
            System.out.println("results "+results+"["+results.length+"]");
            for (int i=0; i<results.length; i++) {
                System.out.println("results "+results);
                model.addElement(results[i].getName());
                
            }
            documentsFoundList.setModel(model);
        }
   /** This method is called from within the constructor to
    * initialize the form.
    * WARNING: Do NOT modify this code. The content of this method is
    * always regenerated by the Form Editor.
    */
    private void initComponents() {//GEN-BEGIN:initComponents
        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        viewConfigMenuItem = new javax.swing.JMenuItem();
        newConfigMenuItem = new javax.swing.JMenuItem();
        exitMenuItem = new javax.swing.JMenuItem();
        helpMenu = new javax.swing.JMenu();
        aboutMenuItem = new javax.swing.JMenuItem();
        tabbedPane = new javax.swing.JTabbedPane();
        shareSplitPane = new javax.swing.JSplitPane();
        filesSplitPane = new javax.swing.JSplitPane();
        ocalContentScrollPane = new javax.swing.JScrollPane();
        localContentTree = new javax.swing.JTree();
        groupContentScrollPane = new javax.swing.JScrollPane();
        documentsFoundList = new javax.swing.JList();
        fileDescScrollPane = new javax.swing.JScrollPane();
        fileDescTree = new javax.swing.JTree();
        jPanel14 = new javax.swing.JPanel();
        groupMembershipPanel = new javax.swing.JPanel();
        joinGroupButton = new javax.swing.JButton();
        renewButton = new javax.swing.JButton();
        leaveGroupButton = new javax.swing.JButton();
        newGroupSubPanel = new javax.swing.JPanel();
        newGroupButton = new javax.swing.JButton();
        newGroupNameTextField = new javax.swing.JTextField();
        availGroupsScrollPane = new javax.swing.JScrollPane();
        availGroupsLit = new javax.swing.JList();

        fileMenu.setText("File");
        viewConfigMenuItem.setText("Item");
        viewConfigMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewConfigMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(viewConfigMenuItem);
        newConfigMenuItem.setToolTipText("Requires that the app be restarted.");
        newConfigMenuItem.setText("New Config");
        newConfigMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newConfigMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(newConfigMenuItem);
        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(exitMenuItem);
        menuBar.add(fileMenu);
        helpMenu.setText("Help");
        helpMenu.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        aboutMenuItem.setText("About");
        aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutMenuItemActionPerformed(evt);
            }
        });

        helpMenu.add(aboutMenuItem);
        menuBar.add(helpMenu);

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        shareSplitPane.setDividerLocation(150);
        shareSplitPane.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        filesSplitPane.setDividerLocation(150);
        ocalContentScrollPane.setViewportBorder(new javax.swing.border.TitledBorder("Local Content"));
        ocalContentScrollPane.setViewportView(localContentTree);

        filesSplitPane.setLeftComponent(ocalContentScrollPane);

        groupContentScrollPane.setBorder(new javax.swing.border.TitledBorder("Group Content"));
        groupContentScrollPane.setViewportView(documentsFoundList);

        filesSplitPane.setRightComponent(groupContentScrollPane);

        shareSplitPane.setLeftComponent(filesSplitPane);

        fileDescScrollPane.setBorder(new javax.swing.border.TitledBorder("File Description"));
        fileDescTree.setBorder(new javax.swing.border.EtchedBorder());
        fileDescScrollPane.setViewportView(fileDescTree);

        shareSplitPane.setRightComponent(fileDescScrollPane);

        tabbedPane.addTab("File Browser", null, shareSplitPane, "");

        jPanel14.setLayout(new java.awt.BorderLayout());

        jPanel14.setEnabled(false);
        joinGroupButton.setToolTipText("Join an available group.");
        joinGroupButton.setText("Join");
        joinGroupButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                joinGroupButtonActionPerformed(evt);
            }
        });

        groupMembershipPanel.add(joinGroupButton);

        renewButton.setToolTipText("Renew membership in a group.");
        renewButton.setText("Renew");
        renewButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                renewButtonActionPerformed(evt);
            }
        });

        groupMembershipPanel.add(renewButton);

        leaveGroupButton.setToolTipText("Leave a group you are currently a member of.");
        leaveGroupButton.setText("Leave");
        leaveGroupButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                leaveGroupButtonActionPerformed(evt);
            }
        });

        groupMembershipPanel.add(leaveGroupButton);

        newGroupSubPanel.setBorder(new javax.swing.border.EtchedBorder());
        newGroupButton.setToolTipText("Create and join a group of the following name.");
        newGroupButton.setText("New Group");
        newGroupButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                newGroupButtonActionPerformed(evt);
            }
        });

        newGroupSubPanel.add(newGroupButton);

        newGroupNameTextField.setColumns(25);
        newGroupNameTextField.setText("Turbogeek2");
        newGroupSubPanel.add(newGroupNameTextField);

        groupMembershipPanel.add(newGroupSubPanel);

        jPanel14.add(groupMembershipPanel, java.awt.BorderLayout.NORTH);

        availGroupsScrollPane.setViewportView(availGroupsLit);

        jPanel14.add(availGroupsScrollPane, java.awt.BorderLayout.CENTER);

        tabbedPane.addTab("Groups", null, jPanel14, "");

        getContentPane().add(tabbedPane, java.awt.BorderLayout.NORTH);

        pack();
    }//GEN-END:initComponents

   private void leaveGroupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_leaveGroupButtonActionPerformed
      //platform.leaveGroup((String)newGroupNameTextField.getText());
   }//GEN-LAST:event_leaveGroupButtonActionPerformed

   private void renewButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_renewButtonActionPerformed
      //platform.renewMembershipInGroup((String)newGroupNameTextField.getText());
   }//GEN-LAST:event_renewButtonActionPerformed

   private void joinGroupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_joinGroupButtonActionPerformed
     //platform.joinGroup((String)newGroupNameTextField.getText());
   }//GEN-LAST:event_joinGroupButtonActionPerformed
   private void newGroupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newGroupButtonActionPerformed
      platform.newGroupContext((String)newGroupNameTextField.getText());
   }//GEN-LAST:event_newGroupButtonActionPerformed
    
    private void viewConfigMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewConfigMenuItemActionPerformed
       net.jxta.protocol.PeerGroupAdvertisement tempAdvertisement = platform.getPeerGroupAdvertisement();
       if (tempAdvertisement != null){
          net.jxta.impl.peergroup.ConfigDialog config = new net.jxta.impl.peergroup.ConfigDialog(platform.getPeerGroup().getPeerAdvertisement());
          
       }else{
          JOptionPane.showMessageDialog(this,"The default peer group is null.", "ERROR",JOptionPane.ERROR_MESSAGE);
       }
       
       
    }//GEN-LAST:event_viewConfigMenuItemActionPerformed
    
    private void newConfigMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newConfigMenuItemActionPerformed
       try {
        /*
         * delete the old platform and put the new config
         * as the default one
         */
          File file = new File("PlatformPeerGroup");
          file.delete();
       } catch (Exception  ex1) {
          System.out.println("Error resetting configuration");
          return;
       }
       JOptionPane.showMessageDialog(this,"The PlatformPeerGroup file has been deleted. Restart the application to edit the configuration.", "ATTENTION",JOptionPane.INFORMATION_MESSAGE);
       
    }//GEN-LAST:event_newConfigMenuItemActionPerformed
    
    private void aboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutMenuItemActionPerformed
       JOptionPane.showMessageDialog(this,
       "Mirror Library \n Created by Daniel Brookshier\nturbogeek@cluck.com",
       "About MirrorLibrary",
       JOptionPane.INFORMATION_MESSAGE);
       
       
    }//GEN-LAST:event_aboutMenuItemActionPerformed
    
    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
       setVisible(false);
       System.exit(0);
    }//GEN-LAST:event_exitMenuItemActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
       System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
       new MirrorLibrary(null).show();
    }
    public JTree getLocalContentTree(){
       return localContentTree;
    }
    public JTree getFileDescTree(){
       return fileDescTree;
    }
    public DefaultTreeModel getLocalContentTreeModel(){
       return (DefaultTreeModel)localContentTree.getModel();
    }

    public DefaultTreeModel getFileDescTreeModel(){
       return (DefaultTreeModel)fileDescTree.getModel();
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane groupContentScrollPane;
    private javax.swing.JPanel newGroupSubPanel;
    private javax.swing.JList documentsFoundList;
    private javax.swing.JTabbedPane tabbedPane;
    private javax.swing.JButton joinGroupButton;
    private javax.swing.JButton renewButton;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JMenuItem aboutMenuItem;
    private javax.swing.JScrollPane fileDescScrollPane;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JScrollPane ocalContentScrollPane;
    private javax.swing.JMenuItem newConfigMenuItem;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenuItem viewConfigMenuItem;
    private javax.swing.JTextField newGroupNameTextField;
    private javax.swing.JButton newGroupButton;
    private javax.swing.JTree fileDescTree;
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JButton leaveGroupButton;
    private javax.swing.JTree localContentTree;
    private javax.swing.JPanel groupMembershipPanel;
    private javax.swing.JList availGroupsLit;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JScrollPane availGroupsScrollPane;
    private javax.swing.JSplitPane filesSplitPane;
    private javax.swing.JSplitPane shareSplitPane;
    // End of variables declaration//GEN-END:variables

}
