package com.sams.jxta.groups.student;

import net.jxta.document.Element;
import net.jxta.document.MimeMediaType;
import net.jxta.document.StructuredDocument;
import net.jxta.document.StructuredDocumentFactory;

/*
 * A Pre Application Form is used as an identity info in the 
 * Authentication Credential.
 * 
 */

public abstract class PreApplicationForm {
    
    public static final String DEPARTMENT_COMPUTER_SCIENCE = "CS";
    public static final String DEPARTMENT_MANAGEMENT       = "MT";
    public static final String DEPARTMENT_ARCHITECTURE     = "AT";

    /*
     * This methods creates a Structured Document representing the PreApp form.
     * This serves as an IdentityInfo in the authentication credential.
     */
    public static final StructuredDocument createPreAppForm(String department){
        
        MimeMediaType type = new MimeMediaType("text","xml");
        StructuredDocument doc =
                StructuredDocumentFactory.newStructuredDocument( type,"PreAppForm" );
        Element e = doc.createElement( "Department",department); 
        doc.appendChild( e );
        return doc;
        
   }
}
